;***********************************
;*  RAMSTRESS v2.0 (c) 1999 Fiery  *
;***********************************

.386
.MODEL FLAT
.STACK 100h
.CODE

;------------------------------------------------------------------------------

lightgrayonblack	EQU	7	; Fekete hatteren vilagosszurke betu
whiteongreen		EQU	2Fh	; Zold hatteren feher betuk
whiteonred		EQU	4Fh	; Voros hatteren feher betuk

str_fault_pos	DB	'Fault occured at ', 0
str_mb		DB	' MB', 0
str_pass	DB	'Pass ', 0
str_ram_det	DB	' MB RAM detected', 0
str_percent	DB	' %   ', 0
vid		DD	0
vidofs		DD	0
pass		DD	0
loopcount	DD	3

;------------------------------------------------------------------------------

@entry:
	CALL	@vidgen		; A karakteres videomemoria cimenek meghatarozasa
	MOV	AH,lightgrayonblack
	CALL	@cls		; Kepernyotorles
	CALL	@parameters	; Parancssori parameterek feldolgozasa
	MOV	AX,0EE42h	; Memoriafoglalas
	MOV	EDX,-1		; EDX = lefoglalni kivant memoria bajtban
				;  -1 = "vegtelen"
	INT	31h		; EAX <- lefoglalt memoria merete
				; EDX <- lefoglalt blokk cime
	ADD	vidofs,320	; 2 sorral lejjebb lepunk
	PUSH	EAX
	SHR	EAX,20		; Osztunk 10486576-tal (eredmeny: x MB)
	INC	EAX		; Felkerekitjuk
	CALL	@write_int	; Kiirjuk a lefoglalt memoria meretet MB-ban
	MOV	ESI,OFFSET str_ram_det
	CALL	@write_string	; Irunk ki szoveget is melle ("detected")
	MOV	ESI,EDX		; Lefoglalt blokk cime
	AND	ESI,0FFFFFFF0h	; 16 bajtos hatarra igazitjuk
	ADD	ESI,10h
	MOV	EDI,ESI
	POP	EAX
	MOV	ECX,EAX		; Lefoglalt blokk merete
	SUB	ECX,10h		; Az igazitas miatt erre szukseg lesz
	SHR	ECX,2		; 4-gyel elosztjuk, mert 32 bites transzfert vegzunk
	CLD
@loop1:
	PUSH	ESI
	MOV	ESI,vid		; A videomemoria kezdete
	ADD	ESI,480		; 3 sorral lejjebb lepunk
	MOV	vidofs,ESI
	MOV	ESI,OFFSET str_pass
	CALL	@write_string	; "Pass"
	POP	ESI
	INC	pass		; Eggyel noveljuk az iteraciot
	MOV	EAX,pass
	CALL	@write_int	; Kiirjuk az aktualis iteracio szamat
	XOR	EAX,EAX		; 00000000h-val indulunk
@loop2:
	CALL	@percent_completed ; Kiirjuk, hogy hany szazaleknal tartunk
	PUSH	ECX
	PUSH	EDI
	REP	STOSD		; Teleirjuk a memoriat az EAX tartalmaval
	POP	EDI
	POP	ECX
	MOV	EBX,EAX		; Az aktualis adatot megorizzuk
	PUSH	ECX
	PUSH	ESI
@loop3:
	LODSD			; Visszatoltjuk a beirt adatokat
	CMP	EAX,EBX		; Ellenorizzuk az olvasas helyesseget
	JNE	@crc_error	; Ha nem stimmel, CRC hibat jelzunk
	DEC	ECX
	JNZ	@loop3

	POP	ESI
	POP	ECX
	MOV	EAX,EBX		; Az aktualis adatot visszarakjuk az EAX-be
	ADD	EAX,01010101h	; A tesztadatot megvaltoztatjuk
	CMP	EAX,-1		; Vegeztunk az aktualis iteracioval?
	JNE	@loop2

	DEC	loopcount	; A kivant iteraciok szamat csokkentjuk
	JNZ	@loop1		; Nem nulla -> johet a kovetkezo iteracio
	MOV	AH,whiteongreen	; Szep zold kepernyovel jelezzuk, hogy minden rendben
	CALL	@cls
	JMP	@leave		; Kilepunk a programbol
@crc_error:
	POP	EDI
	POP	ECX
	SUB	ESI,EDI		; Kiszamitjuk, hogy hol hibazik a memoria
	SHR	ESI,20		; MB-ban szeretnenk latni
	PUSH	ESI
	MOV	AL,whiteonred
	CALL	@cls2		; Vorosre allitjuk a hatterszint
	MOV	EAX,vid		; A videomemoria kezdete
	ADD	EAX,1600	; 10 sorral lejjebb lepunk
	MOV	vidofs,EAX
	MOV	ESI,OFFSET str_fault_pos ; "Fault occured at"
	CALL	@write_string
	POP	EAX
	CALL	@write_int	; Kiirjuk, hogy hol hibazik a memoria
	MOV	ESI,OFFSET str_mb
	CALL	@write_string	; "MB"

	JMP	@leave
@leave:
	MOV	AX,4C00h
	INT	21h

;------------------------------------------------------------------------------

firstdigit	DB	0
places		DD	1000000000
		DD	100000000
		DD	10000000
		DD	1000000
		DD	100000
		DD	10000
		DD	1000
		DD	100
		DD	10
		DD	1

@write_int:
	PUSH	EAX
	PUSH	EBX
	PUSH	ECX
	PUSH	EDX
	PUSH	ESI
	MOV	firstdigit,0	; Az elso igazi szamjegynel 1-re allitodik
	MOV	ECX,10		; 10 helyertekunk van
	MOV	ESI,OFFSET places ; Helyertekek
@wi_loop:
	CMP	ECX,1		; Az utolso helyertekhez ertunk?
	JNE	@wi_cont
	MOV	firstdigit,1	; Az utolso helyerteket mindenkeppen kiirjuk
@wi_cont:
	CALL	@digit		; Kiirjuk a szamjegyet (ha kell)
	ADD	ESI,4		; Kovetkezo helyertekre lepunk
	LOOP	@wi_loop
	POP	ESI
	POP	EDX
	POP	ECX
	POP	EBX
	POP	EAX
	RET
@digit:
	XOR	EDX,EDX
	MOV	EBX,[ESI]	; Kivesszuk a helyerteket
	DIV	EBX		; Elosztjuk a megmaradt szamunkat a helyertekkel
	PUSH	EDX
	MOV	DL,AL
	CMP	DL,0		; 0 a kiirando szamjegy?
	JNE	@d_cont1
	CMP	firstdigit,0	; Volt mar nem 0 szamjegy?
	JE	@d_end		; Meg nem volt, nem kell kiirnunk
	JMP	@d_cont2
@d_cont1:
	MOV	firstdigit,1	; Nem 0 a kiirando szamjegy, mindenkeppen kiirjuk
@d_cont2:
	ADD	DL,'0'
	CALL	@write_char	; Kiirjuk a szamjegyet
@d_end:
	POP	EDX
	MOV	EAX,EDX		; Csak az osztas utani maradekot visszuk tovabb
	RET

;------------------------------------------------------------------------------

@parameters:
	PUSH	EAX
	PUSH	EBX
	PUSH	ECX
	PUSH	EDX
	PUSH	ESI
	PUSH	EDI
	MOV	AX,0EE02h	; DOS32 cim informaciok
	INT	31h		; ESI <- PSP cime
	ADD	ESI,81h		; [PSP+81h] = parancssori parameterek kezdete
	CLD
@p_loop:
	LODSB			; Betoltunk a PSP-rol egy karaktert
	CMP	AL,0Dh		; Soremeles = parancssori parameterek vege
	JE	@p_end		; Vegeztunk a parancssori parameterekkel
	CMP	AL,'l'
	JE	@p_set_loop	; L parameter = vegtelen iteracio
	CMP	AL,'L'
	JE	@p_set_loop	; L parameter = vegtelen iteracio
	JMP	@p_loop
@p_set_loop:
	MOV	loopcount,7FFFFFFFh ; "Majdnem" vegtelen iteracio beallitasa
	JMP	@p_loop
@p_end:
	POP	EDI
	POP	ESI
	POP	EDX
	POP	ECX
	POP	EBX
	POP	EAX
	RET

;------------------------------------------------------------------------------

@percent_completed:
	PUSH	EAX
	PUSH	EBX
	PUSH	EDX
	PUSH	ESI
	AND	EAX,0FFh	; Melyik adatnal is tartunk?
	XOR	EDX,EDX
	MOV	EBX,100		; Beszorozzuk 100-zal (a szazalek miatt)
	MUL	EBX
	MOV	EBX,256		; Elosztjuk 256-tal (0-FFh-ig mennek az adatok ugyebar)
	XOR	EDX,EDX
	DIV	EBX
	MOV	ESI,vid		; A videomemoria kezdete
	ADD	ESI,640		; 4 sorral lejjebb lepunk
	MOV	vidofs,ESI
	CALL	@write_int	; Kiirjuk az eredmenyt
	MOV	ESI,OFFSET str_percent
	CALL	@write_string	; "%"
	POP	ESI
	POP	EDX
	POP	EBX
	POP	EAX
	RET

;------------------------------------------------------------------------------

@cls:				; Torli a kepernyot egy megadott szinnel
	PUSH	EAX
	PUSH	ECX
	PUSH	EDI
	MOV	EDI,vid		; A videomemoria kezdete
	MOV	ECX,2000	; 80 x 25 db karakter
	MOV	AL,' '		; AH-ban van az attributum
	CLD
	REP	STOSW		; Kiirjuk a 2000 db szokozt
	POP	EDI
	POP	ECX
	POP	EAX
	RET

;------------------------------------------------------------------------------

@cls2:				; A kepernyon levo karakterek szinet allitja be
	PUSH	ECX
	PUSH	EDI
	MOV	EDI,vid		; A videomemoria kezdete
	INC	EDI		; Az attributumok 1 bajttal el vannak tolva
	MOV	ECX,2000	; 80 x 25 db karakter
	CLD
@c2_loop:
	STOSB
	INC	EDI
	LOOP	@c2_loop
	POP	EDI
	POP	ECX
	RET

;------------------------------------------------------------------------------

@vidgen:
	PUSH	EAX
	PUSH	EBX
	PUSH	ECX
	PUSH	EDX
	PUSH	ESI
	PUSH	EDI
	MOV	AX,0EE02h	; DOS32 cim informaciok
	INT	31h		; EBX <- A program linearis cime
	MOV	EAX,0B8000h	; A karakteres videomemoria cimenek kiszamitasa
	SUB	EAX,EBX
	MOV	vid,EAX		; A karakteres videomemoria cime
	MOV	vidofs,EAX	; Aktualis pozicio a videomemorian belul
	POP	EDI
	POP	ESI
	POP	EDX
	POP	ECX
	POP	EBX
	POP	EAX
	RET

;------------------------------------------------------------------------------

@write_char:
	PUSH	EDI
	MOV	EDI,vidofs	; Aktualis pozicio a videomemorian belul
	MOV	[EDI],DL	; Beirjuk a karaktert
	ADD	EDI,2		; 1 karakterrel arrebb lepunk
	MOV	vidofs,EDI	; Aktualis pozicio beallitasa
	POP	EDI
	RET

;------------------------------------------------------------------------------

@write_string:
	PUSH	EAX
	PUSH	EDX
	PUSH	ESI
	CLD
@ws_loop:
	LODSB
	CMP	AL,0		; ASCIIZ sztring: 0-nal megallunk
	JE	@ws_end
	MOV	DL,AL
	CALL	@write_char
	JMP	@ws_loop
@ws_end:
	POP	ESI
	POP	EDX
	POP	EAX
	RET

;------------------------------------------------------------------------------

	END	@entry
